package listFW.visitor;

import listFW.*;

/**
 * 
 */
public class ReverseList<T> implements IListAlgo<T,IList<T>, IListFactory<?>>  {
    
    public IMTList<T> emptyCase(IMTList<? extends T> host, IListFactory<?> ... fac) {
        return ((IListFactory<T>)fac[0]).makeEmptyList();  // Generates "unchecked cast" warning
    }
    public INEList<T> nonEmptyCase(INEList<? extends T> host, IListFactory<?> ... fac) {
        final IListFactory<T> f = (IListFactory<T>)fac[0];
        return host.getRest().execute(new IListAlgo<T,INEList<T>, INEList<T>>()  {
            public INEList<T> emptyCase(IMTList<? extends T> h, INEList<T> ... acc) {
                return acc[0];
            }
            public INEList<T> nonEmptyCase(INEList<? extends T> h, INEList<T>... acc) {
                return h.getRest().execute(this, f.makeNEList(h.getFirst(), acc[0]));
            }
        },f.makeNEList(host.getFirst(), f.makeEmptyList()));
    }
}


